'Compilable Example:
#Compiler PBWin 10
#Compile Exe  "gbsearchsimple.exe"
#Dim All

#Debug Display On
#Debug Error On

%Unicode=1

#Include "Win32api.inc"

#Resource Icon logo "images\gbsearchsimple.ico"
#Resource Icon xopen "images\open.ico"
#Resource Icon xsearch "images\search.ico"
#Resource Icon xsearchfolders "images\searchfolder.ico"
#Resource Icon xsearchfiles "images\searchfileb.ico"
#Resource Icon xsearchtext "images\searchtext.ico"
#Resource Icon xsettings "images\settings.ico"
#Resource Icon xhelp "images\help.ico"
#Resource Icon xfont "images\font.ico"
#Resource Icon xup "images\sortascending.ico"
#Resource Icon xdown "images\sortdescending.ico"
#Resource Icon xcancel "images\cancel.ico"
#Resource Icon xwithin "images\searchwithin.ico"

Enum Equates Singular
   IDC_Toolbar    = 500
   IDC_SearchTerm
   IDC_StartFolder
   IDC_LabelH
   IDC_SearchTermL
   IDC_StartFolderL
   IDC_SearchTermHistory
   IDC_StartFolderHistory

   IDC_FolderList
   IDC_MatchList

   IDT_Folder
   IDT_Search
   IDT_SearchFolders
   IDT_SearchFiles
   IDT_SearchText
   IDT_SearchWithin
   IDT_Settings
   IDT_Cancel
   IDT_Font
   IDT_Help

   IDM_Clear
   IDM_UseSelected
   IDM_Method
   IDM_UseC
   IDM_Sep
   IDM_Cut
   IDM_Copy
   IDM_Paste
   IDM_Delete
   IDM_Return
End Enum,

$Ver = "1.0"

$SessionFolders = "tempfiles\gbsearchsimple_folders.dat"
$SessionMatch = "tempfiles\gbsearchsimple_match.dat"

Global hDlg,hFont,hFontC,hImageList,hImageListLV,hHook,hContext As Dword
Global hFolderList,hMatchList,hContextT,hThread As Dword
Global SplitHInWork, HBarLeft, CancelSearch, OldProc As Long
Global Matches(),Folders() As DirData, tempArray() As String
Global SortDirection,FolderCount,MatchCount As Long
Global TextExtensions, StartFolder, SearchTerm, FontName, History() As WStringZ * %Max_Path
Global SearchInWork, SearchWithin, SearchType, FontSize, FontStyle As Long
Global qstop, qstart, qFreq As Quad, FileContent$

Function PBMain()
   Dialog New Pixels, 0, "gbSearchSimple   v" + $ver,300,300,410,340, %WS_OverlappedWindow Or %WS_ClipChildren To hDlg
   Dialog Set Icon hDlg, "logo"
   CreateToolbar
   Control Add Label, hDlg, %IDC_LabelH, "",  200, 220, 6, 125, %WS_Child Or %SS_Notify , %WS_Ex_ClientEdge  ' up/down - does horizontal split
   Control Set Color hDlg, %IDC_LabelH, %Black, %Blue

   Control Add Label, hDlg, %IDC_SearchTermL, "Search String:",   5, 55, 100, 15
   Control Add Label, hDlg, %IDC_StartFolderL, "Start Folder:", 110, 55, 100, 15
   Control Add TextBox, hDlg, %IDC_SearchTerm, "",5,75,100,20
   Control Add TextBox, hDlg, %IDC_StartFolder, "",110,75,400,20
   Control Add ListBox, hDlg, %IDC_SearchTermHistory, ,  5, 95, 100, 90, %LBS_Sort Or %LBS_Notify Or %WS_TabStop Or %WS_VScroll Or %LBS_NoIntegralHeight, %WS_Ex_ClientEdge
   Control Add ListBox, hDlg, %IDC_StartFolderHistory, ,  110, 95, 160, 90, %LBS_Sort Or %LBS_Notify Or %WS_TabStop Or %WS_VScroll Or %LBS_NoIntegralHeight, %WS_Ex_ClientEdge

   'create imagelist
   ImageList New Icon 16,16,24,3 To hImageListLV
   ImageList Add Icon hImageListLV, "xup"
   ImageList Add Icon hImageListLV, "xdown"

   Control Add ListView, hDlg, %IDC_FolderList, "",  5, 190, 160, 80, %WS_Child Or %WS_TabStop Or %WS_Visible Or %LVS_ShowSelAlways Or %LVS_Report Or %LVS_OwnerData Or %LVS_ShowSelAlways Or %LVS_SingleSel
   ListView Insert Column hDlg, %IDC_FolderList, 1, "All Folders", 1200, 0
   Control Handle hDlg, %IDC_FolderList To hFolderList
   SendMessage (hFolderList, %WM_NOTIFYFORMAT, hDlg, %NF_REQUERY)
   Header_SetImageList ListView_GetHeader(hFolderList), hImagelistLV

   Control Add ListView, hDlg, %IDC_MatchList, "", 170, 190, 160, 80, %WS_Child Or %WS_TabStop Or %WS_Visible Or %LVS_ShowSelAlways Or %LVS_Report Or %LVS_OwnerData Or %LVS_ShowSelAlways Or %LVS_SingleSel
   ListView Insert Column hDlg, %IDC_MatchList, 1, "Matching Items", 1200, 0

   Control Handle hDlg, %IDC_MatchList To hMatchList
   SendMessage (hMatchList, %WM_NOTIFYFORMAT, hDlg, %NF_REQUERY)
   Header_SetImageList ListView_GetHeader(hMatchList), hImagelistLV

   Dialog Show Modal hDlg Call DlgProc()
End Function

CallBack Function DlgProc() As Long
   Local i,x,y,w,h,Row As Long, PTT As TooltipText Ptr
   Local LVData As NM_ListView, temp$, pt As Point, pLVDI As LV_DispInfo Ptr
   Select Case Cb.Msg
      Case %WM_InitDialog
         ReDim History(9)
         QueryPerformanceFrequency qFreq
         BuildAcceleratorTable
         OldProc& = SetWindowLong(GetDlgItem(hDlg, %IDC_SearchTerm), %GWL_WndProc, CodePtr(NewTextProc))  'subclass
         OldProc& = SetWindowLong(GetDlgItem(hDlg, %IDC_StartFolder), %GWL_WndProc, CodePtr(NewTextProc))  'subclass
         Settings_ini "get"
         'Text Search (Toolbar and Label content)
         Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_SearchFolders, %TBState_Checked * IIf(SearchType=0,1,0) Or %TBState_Enabled
         Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_SearchFiles, %TBState_Checked * IIf(SearchType=1,1,0) Or %TBState_Enabled
         Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_SearchText, %TBState_Checked * IIf(SearchType=2,1,0) Or %TBState_Enabled
         Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_SearchWithin, %TBState_Checked * SearchWithin Or %TBState_Enabled
         'Fonts
         Font New "Tahoma", 10, 0 To hFontC
         For i = %IDC_Toolbar To %IDC_StartFolderHistory
            Control Set Font hDlg, i, hFontC
         Next i
         'Context Menu
         CreateContextMenus
         'Initialize Control Content
         Control Set Text hDlg, %IDC_SearchTerm, SearchTerm
         Control Set Text hDlg, %IDC_StartFolder, StartFolder
         SetControlFonts
         CreateSubFolders
         LoadSession
         For i = 4 To 0 Step - 1 : ListBox Insert hDlg, %IDC_SearchTermHistory, 1, History(i)  : Next i
         For i = 9 To 5 Step - 1 : ListBox Insert hDlg, %IDC_StartFolderHistory, 1, History(i) : Next i
         Dialog Get Client hDlg To w,h
         If HBarLeft = 0 Then HBarLeft = 150
         Control Set Loc hDlg, %IDC_LabelH, HBarLeft, 210
      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDM_Method
               Incr SearchType
               If SearchType > 2 Then SearchType = 0
               SetSearchType

            Case %IDM_Clear
               FolderCount = 0
               MatchCount = 0
               ReDim Folders(0), Matches(0)
               Folders(0).FileName = "no folders"
               Matches(0).FileName = "no matches"
               ListView_SetItemCountEx(hFolderList, 1, %LVSICF_noInvalidateAll) 'max rows
               ListView_SetItemCountEx(hMatchList, 1, %LVSICF_noInvalidateAll) 'max rows
               ListView Set Header hDlg, %IDC_FolderList, 1, "All Folders  (0)"
               ListView Set Header hDlg, %IDC_MatchList, 1, IIf$(SearchType,"Matching Files","Matching Folders") + "  (0)"

            Case %IDM_UseSelected
               Select Case GetFocus
                  Case GetDlgItem(hDlg, %IDC_FolderList)
                     ListView Get Select hDlg, %IDC_FolderList To i
                     ListView Get Text hDlg, %IDC_FolderList, i,1 To temp$
                     Control Set Text hDlg, %IDC_StartFolder, temp
                  Case GetDlgItem(hDlg, %IDC_MatchList)
                     ListView Get Select hDlg, %IDC_MatchList To i
                     ListView Get Text hDlg, %IDC_MatchList, i,1 To temp$
                     Control Set Text hDlg, %IDC_StartFolder, temp
               End Select

            Case %IDM_UseC
               Control Set Text hDlg, %IDC_StartFolder, "c:\"

            Case %IDM_Cut     : SendMessage GetFocus, %WM_CUT, 0, 0
            Case %IDM_Copy    : SendMessage GetFocus, %WM_COPY, 0, 0
            Case %IDM_Paste   : SendMessage GetFocus, %WM_PASTE, 0, 0
            Case %IDM_Delete  : SendMessage GetFocus, %WM_CLEAR, 0, 0

            Case %IDM_Return
               Select Case GetFocus
                  Case GetDlgItem(hDlg, %IDC_FolderList)
                     ListView Get Select hDlg, %IDC_FolderList To i
                     ListView Get Text hDlg, %IDC_FolderList, i,1 To temp$
                     i = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)
                  Case GetDlgItem(hDlg, %IDC_MatchList)
                     ListView Get Select hDlg, %IDC_MatchList To i
                     ListView Get Text hDlg, %IDC_MatchList, i,1 To temp$
                     i = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)
                  Case GetDlgItem(hDlg, %IDC_SearchTerm)
                     If SearchInWork = 0 Then
                        SearchInWork = 1
                        Thread Create SearchForFolders(0) To hThread
                        Thread Close hThread To hThread
                        SearchInWork = 0
                     End If
                  Case GetDlgItem(hDlg, %IDC_StartFolder)
                     If SearchInWork = 0 Then
                        SearchInWork = 1
                        Thread Create SearchForFolders(0) To hThread
                        SearchInWork = 0
                     End If
                  Case GetDlgItem(hDlg, %IDC_SearchTermHistory)
                     ListBox Get Select hDlg, %IDC_SearchTermHistory To i
                     ListBox Get Text hDlg, %IDC_SearchTermHistory To temp$
                     Control Set Text hDlg, %IDC_SearchTerm, temp$
                     Control Set Focus hDlg, %IDC_SearchTerm

                  Case GetDlgItem(hDlg, %IDC_StartFolderHistory)
                     ListBox Get Select hDlg, %IDC_StartfolderHistory To i
                     ListBox Get Text hDlg, %IDC_StartFolderHistory To temp$
                     Control Set Text hDlg, %IDC_StartFolder, temp$
                     Control Set Focus hDlg, %IDC_StartFolder
               End Select

            Case %IDT_Cancel
               CancelSearch = 1

            Case %IDT_SearchWithin
               SearchWithin Xor=1

            Case %IDT_SearchFolders : SearchType = 0 : SetSearchType
            Case %IDT_SearchFiles   : SearchType = 1 : SetSearchType
            Case %IDT_SearchText    : SearchType = 2 : SetSearchType

            Case %IDC_SearchTermHistory
               If Cb.CtlMsg = %LBN_DblClk Then
                  ListBox Get Select hDlg, %IDC_SearchTermHistory To i
                  ListBox Get Text hDlg, %IDC_SearchTermHistory, i To temp$
                  Control Set Text hDlg, %IDC_SearchTerm, temp$
               End If

            Case %IDC_StartFolderHistory
               If Cb.CtlMsg = %LBN_DblClk Then
                  ListBox Get Select hDlg, %IDC_StartFolderHistory To i
                  ListBox Get Text hDlg, %IDC_StartFolderHistory, i To temp$
                  Control Set Text hDlg, %IDC_StartFolder, temp$
               End If

            Case %IDT_Folder
               SelectFolder

            Case %IDT_Font
               SelectControlFont

            Case %IDT_Settings
               Dialog Get Loc hDlg To w,h
               hHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProcIndent), GetModuleHandle(""), GetCurrentThreadId)
               temp$ = InputBox$("", "Set Text File Extensions", TextExtensions, w+40,h+150)
               temp$ = Trim$(temp$)
               If Len(temp$) Then TextExtensions = temp$
               UnhookWindowsHookEx hHook

            Case %IDT_Help
               i = ShellExecute(hDlg, "Open", "http://www.garybeene.com/sw/gbsearchsimple.htm", $Nul, $Nul, %SW_ShowNormal)

            Case %IDT_Search
               If SearchInWork = 0 Then
                  SearchInWork = 1
                  Thread Create SearchForFolders(0) To hThread
                  SearchInWork = 0
               End If
         End Select

      Case %WM_ContextMenu
         pt.x = Lo(Integer,Cb.LParam) : pt.y = Hi(Integer, Cb.LParam)
         ScreenToClient hDlg, pt
         If (ChildWindowFromPoint(hDlg,pt) = GetDlgItem(hDlg, %IDC_FolderList)) Or (ChildWindowFromPoint(hDlg,pt) = GetDlgItem(hDlg, %IDC_MatchList)) Then
            x = Lo(Integer,Cb.LParam) : y = Hi(Integer, Cb.LParam)
            TrackPopupMenu hContext, %TPM_LeftAlign, x, y, 0, Cb.Hndl, ByVal 0
         End If

      Case %WM_Notify
         Select Case Cb.NmId
            Case %IDT_Folder To %IDT_Help
               Select Case Cb.NmCode
                  Case %TTN_GetDispInfo
                     PTT = Cb.LParam
                     Select Case Cb.NmId
                        Case %IDT_Folder        : @PTT.@lpszText = "Select Starting Folder"
                        Case %IDT_Search        : @PTT.@lpszText = "Find All Folders and Matching Folders/Files Beneath the Starting Folder"
                        Case %IDT_SearchWithin  : @PTT.@lpszText = "Search Within Existing Displayed Folders List"
                        Case %IDT_SearchFolders : @PTT.@lpszText = "Search for Folders Whose Names Contain the Search String"
                        Case %IDT_SearchFiles   : @PTT.@lpszText = "Search for Files Whose Names Contain the Search String "
                        Case %IDT_SearchText    : @PTT.@lpszText = "Search for Text Files Containing the Text String"
                        Case %IDT_Cancel        : @PTT.@lpszText = "Cancel Current Search"
                        Case %IDT_Settings      : @PTT.@lpszText = "Set Text File Extension List"
                        Case %IDT_Help          : @PTT.@lpszText = "Open Online Help Page"
                     End Select
               End Select
            Case %IDC_FolderList
               Select Case Cb.NmCode
                  Case %LVN_GetDispInfo             'notification to ask for data
                     pLVDI = Cb.LParam               'pointer to LVDISPINFO structure for requested subitem
                     Row = @pLVDI.item.iItem         'row being asked for
                     @pLVDI.item.pszText = VarPtr(Folders(Row).FileName) 'text sent to ListView
                  Case %NM_DblClk
                     ListView Get Select hDlg, %IDC_FolderList To i
                     ListView Get Text hDlg, %IDC_FolderList, i,1 To temp$
                     i = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)
                  Case %LVN_ColumnClick
                     Type Set LVData = Cb.NmHdr$(SizeOf(LVData))
                     SortDirection Xor= 1
                     If SortDirection Then
                        Array Sort Folders(), Call SortAscend
                     Else
                        Array Sort Folders(), Call SortDescend
                     End If
                     SetHeaderIconsOnRight LVData.iSubItem, ListView_GetHeader(hFolderList)
                     Control ReDraw hdlg, %IDC_FolderList
               End Select
            Case %IDC_MatchList
               Select Case Cb.NmCode
                  Case %LVN_GetDispInfo             'notification to ask for data
                     pLVDI = Cb.LParam               'pointer to LVDISPINFO structure for requested subitem
                     Row = @pLVDI.item.iItem         'row being asked for
                     @pLVDI.item.pszText = VarPtr(Matches(Row).FileName) 'text sent to ListView
                  Case %NM_DblClk
                     ListView Get Select hDlg, %IDC_MatchList To i
                     ListView Get Text hDlg, %IDC_MatchList, i,1 To temp$
                     i = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)
                  Case %LVN_ColumnClick
                     Type Set LVData = Cb.NmHdr$(SizeOf(LVData))
                     SortDirection Xor= 1
                     If SortDirection Then
                        Array Sort Matches(), Call SortAscend
                     Else
                        Array Sort Matches(), Call SortDescend
                     End If
                     SetHeaderIconsOnRight LVData.iSubItem, ListView_GetHeader(hMatchList)
                     Control ReDraw hdlg, %IDC_MatchList
               End Select
         End Select

      Case %WM_Size
         ResizeWindow

      Case %WM_SetCursor
         i = GetDlgCtrlID (Cb.WParam)  'determine which over which label control mouse was moved
         If i = %IDC_LabelH Then MousePtr 9 : Function = 1    '9 = horizontal cursor
         Select Case Hi(Word, Cb.LParam)
            Case %WM_LButtonDown
               If i = %IDC_LabelH Then SplitHInWork = 1 : MoveBarLeftRight
            Case %WM_MouseMove
               If SplitHInWork Then MoveBarLeftRight
            Case %WM_LButtonUp
               If SplitHInWork Then
                  SplitHInWork = 0  'sets flags to say splitter action has ended
                  MoveBarLeftRight
                  Control Set Color hDlg, %IDC_LabelH, %Black, %Blue
                  ResizeWindow
               End If
         End Select
      Case %WM_Destroy
         Control Get Text hDlg, %IDC_SearchTerm To SearchTerm
         Control Get Text hDlg, %IDC_StartFolder To StartFolder
         SaveSession
         Settings_ini "save"
   End Select
End Function

Sub MoveBarLeftRight
   Local pt As Point, w,h As Long
   'get new HBarLeft position
   GetCursorPos pt               'pt has xy screen coordinates
   ScreenToClient hDlg, pt       'pt now has client coordinates
   HBarLeft = pt.x-3
   'splitterbar colors - change colors when move is in work
   Control Set Color hDlg, %IDC_LabelH, %Black, %Red
   'resize splitterbars
   Dialog Get Client hDlg To w,h
   Control Set Loc hDlg, %IDC_LabelH, HBarLeft, 210
End Sub


Sub ResizeWindow
   Local w,h As Long
   Dialog Get Client hDlg To w,h
   Control Set Size hDlg, %IDC_LabelH, 6, h - 215

   Control Set Size hDlg, %IDC_StartFolder, w - 115, 20
   Control Set Size hDlg, %IDC_StartFolderHistory, w - 115, 90

   Control Set Loc  hDlg, %IDC_MatchList, HBarLeft + 10, 190
   Control Set Size hDlg, %IDC_MatchList, w - HBarLeft - 15, h - 205
   Control Set Size hDlg, %IDC_FolderList, HBarLeft - 10, h - 205
   Dialog ReDraw hDlg
End Sub

Sub GetFolderList
   'Search for list of folders, from StartFolder down, including all subfolders
   Local iPOS As Long, tempDIR As DirData, temp$
   ReDim Folders(100000)
   FolderCount = 1
   Folders(0).FileName = StartFolder
   While Len(Folders(iPOS).FileName)
      temp$ = Dir$(Folders(iPOS).FileName + "\*.*", Only %SubDir To tempDir)  'subfolders only
      tempDir.FileName = StartFolder + "\" + tempDir.FileName
      While Len(temp$)
         Incr FolderCount
         If FolderCount > UBound(Folders) Then ReDim Preserve Folders(UBound(Folders) + 20000)
         Folders(FolderCount-1) =  tempDir
         Folders(FolderCount-1).FileName = Folders(iPos).FileName + "\" + temp$
         temp$ =  Dir$ (Next, To tempDir)
         tempDir.FileName = StartFolder + "\" + tempDir.FileName
         If CancelSearch Then Exit Loop   'Detect cancel search------------------------------------------------
      Wend
      Incr iPOS
      If CancelSearch Then Exit Loop   'Detect cancel search------------------------------------------------
   Wend
   ReDim Preserve Folders(FolderCount-1)
   ListView Set Header hDlg, %IDC_FolderList, 1, "All Folders  (" + Trim$(Str$(FolderCount)) + ")"
   ListView_SetItemCountEx(hFolderList, FolderCount, %LVSICF_noInvalidateAll) 'max rows
   Control ReDraw hDlg, %IDC_FolderList
End Sub

Sub Settings_INI(Task$)
   Local x,y As Long
   Local xResult, yResult, temp, INIFileName As WStringZ*%Max_Path
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "100", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "100", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "550", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "500", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult), Val(yResult)   'width/height

      'get value for string variables
      Getprivateprofilestring "All", "FontName", "Tahoma", FontName, %Max_Path, INIFileName
      Getprivateprofilestring "All", "StartFolder", Exe.Path$, StartFolder, %Max_Path, INIFileName
      Getprivateprofilestring "All", "SearchTerm", "picture", SearchTerm, %Max_Path, INIFileName
      Getprivateprofilestring "All", "TextExtensions", ".txt.bas.inc", TextExtensions, %Max_Path, INIFileName
      For x = 0 To 9
         Getprivateprofilestring "All", "History" + Format$(x,"00"), "", History(x), %Max_Path, INIFileName
      Next i
      If History(0) = "" Then History(0) = "gbapps"
      If History(1) = "" Then History(1) = "data"
      If History(2) = "" Then History(2) = "movie"
      If History(3) = "" Then History(3) = "image"
      If History(4) = "" Then History(4) = "unused"

      If History(5) = "" Then History(5) = "c:\"
      If History(6) = "" Then History(6) = "c:\data"
      If History(7) = "" Then History(7) = "c:\data\gbapps"
      If History(8) = "" Then History(8) = "d:\"
      If History(9) = "" Then History(9) = "d:\data"

      'get value for numeric variables
      Getprivateprofilestring "All", "FontSize", "10", temp, %Max_Path, INIFileName:  FontSize = Val(temp)
      Getprivateprofilestring "All", "FontStyle", "0", temp, %Max_Path, INIFileName:  FontStyle = Val(temp)
      Getprivateprofilestring "All", "HBarLeft", "250", temp, %Max_Path, INIFileName:  HBarLeft = Val(temp)
      Getprivateprofilestring "All", "SearchType", "0", temp, %Max_Path, INIFileName:  SearchType = Val(temp)
      Getprivateprofilestring "All", "SearchWithin", "0", temp, %Max_Path, INIFileName:  SearchWithin = Val(temp)
      Getprivateprofilestring "All", "FolderCount", "0", temp, %Max_Path, INIFileName:  FolderCount = Val(temp)
      Getprivateprofilestring "All", "MatchCount", "0", temp, %Max_Path, INIFileName:  MatchCount = Val(temp)
   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
      WritePrivateProfileString "All", "FontName",FontName, INIFileName
      WritePrivateProfileString "All", "StartFolder",StartFolder, INIFileName
      WritePrivateProfileString "All", "SearchTerm",SearchTerm, INIFileName
      WritePrivateProfileString "All", "TextExtensions",TextExtensions, INIFileName
      For x = 0 To 9
         WritePrivateProfileString "All", "History" + Format$(x,"00"),History(x), INIFileName
      Next x
      'save numeric variables
      WritePrivateProfileString "All", "FontSize", Str$(FontSize), INIFileName
      WritePrivateProfileString "All", "FontStyle", Str$(FontStyle), INIFileName
      WritePrivateProfileString "All", "HBarLeft", Str$(HBarLeft), INIFileName
      WritePrivateProfileString "All", "SearchType", Str$(SearchType), INIFileName
      WritePrivateProfileString "All", "SearchWithin", Str$(SearchWithin), INIFileName
      WritePrivateProfileString "All", "FolderCount", Str$(FolderCount), INIFileName
      WritePrivateProfileString "All", "MatchCount", Str$(MatchCount), INIFileName
   End If
End Sub

Sub CreateToolbar
   ImageList New Icon 24,24,24,10 To hImageList
   ImageList Add Icon hImageList, "xopen"          '1
   ImageList Add Icon hImageList, "xsearch"        '2
   ImageList Add Icon hImageList, "xsettings"      '3
   ImageList Add Icon hImageList, "xhelp"          '4
   ImageList Add Icon hImageList, "xfont"          '5
   ImageList Add Icon hImageList, "xsearchfolders" '6
   ImageList Add Icon hImageList, "xsearchfiles"   '7
   ImageList Add Icon hImageList, "xsearchtext"    '8
   ImageList Add Icon hImageList, "xcancel"        '9
   ImageList Add Icon hImageList, "xwithin"        '10

   Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0,%TbStyle_Tooltips Or %TbStyle_Flat

   Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0
   Toolbar Add Button    hDlg, %IDC_Toolbar, 1,  %IDT_Folder, %BTNS_Button, "Select"
   Toolbar Add Button    hDlg, %IDC_Toolbar, 2,  %IDT_Search,  %BTNS_Button, "Search"
   Toolbar Add Separator hDlg, %IDC_Toolbar, 20
   Toolbar Add Button    hDlg, %IDC_Toolbar, 9,  %IDT_Cancel,  %BTNS_Button, "Cancel"
   Toolbar Add Separator hDlg, %IDC_Toolbar, 20
   Toolbar Add Button    hDlg, %IDC_Toolbar, 6,  %IDT_SearchFolders,  %BTNS_Check Or %BTNS_Group, "Folders"
   Toolbar Add Button    hDlg, %IDC_Toolbar, 7,  %IDT_SearchFiles,  %BTNS_Check Or %BTNS_Group, "Files"
   Toolbar Add Button    hDlg, %IDC_Toolbar, 8,  %IDT_SearchText,  %BTNS_Check Or %BTNS_Group, "Text"

   Toolbar Add Separator hDlg, %IDC_Toolbar, 20
   Toolbar Add Button    hDlg, %IDC_Toolbar, 5,  %IDT_Font,  %BTNS_Button, "Font"
   Toolbar Add Button    hDlg, %IDC_Toolbar, 10,  %IDT_SearchWithin,  %BTNS_Check, "Within"
   Toolbar Add Button    hDlg, %IDC_Toolbar, 3,  %IDT_Settings,  %BTNS_Button, "Settings"
   Toolbar Add Button    hDlg, %IDC_Toolbar, 4,  %IDT_Help,  %BTNS_Button, "Help"
End Sub

Sub CreateSubFolders
   If IsFolder (Exe.Path$ + "images") = %False Then MkDir Exe.Path$ + "images"
   If IsFolder (Exe.Path$ + "tempfiles") = %False Then MkDir Exe.Path$ + "tempfiles"
End Sub

Sub SetControlFonts
   Font New FontName, FontSize, FontStyle To hFont
   Control Set Font hDlg, %IDC_FolderList, hFont
   Control Set Font hDlg, %IDC_MatchList, hFont
End Sub

Sub LoadSession
   'Folders
   If (FolderCount>0) And IsFile($SessionFolders) Then
      ReDim Folders(FolderCount-1)
      Open $SessionFolders For Binary As #1
      Get #1, , Folders()
      Close #1
      ListView Set Header hDlg, %IDC_FolderList, 1, "All Folders  (" + Trim$(Str$(FolderCount)) + ")"
      ListView_SetItemCountEx(hFolderList, FolderCount, %LVSICF_noInvalidateAll) 'max rows
   Else
      FolderCount = 0
      ReDim Folders(0)
      Folders(0).FileName = "no folders"
      ListView Set Header hDlg, %IDC_FolderList, 1, "All Folders  (0)"
      ListView_SetItemCountEx(hFolderList, 1, %LVSICF_noInvalidateAll) 'max rows
   End If
   'Matches
   If (MatchCount>0) And IsFile($SessionMatch) Then
      ReDim Matches(MatchCount-1)
      Open $SessionMatch For Binary As #1
      Get #1, , Matches()
      Close #1
      ListView Set Header hDlg, %IDC_MatchList, 1, IIf$(SearchType,"Matching Files","Matching Folders") + "  (" + Trim$(Str$(MatchCount)) + ")"
      ListView_SetItemCountEx(hMatchList, MatchCount, %LVSICF_noInvalidateAll) 'max rows
   Else
      MatchCount = 0
      ReDim Matches(0)
      Matches(0).FileName = "no matches"
      ListView Set Header hDlg, %IDC_MatchList, 1, IIf$(SearchType,"Matching Files","Matching Folders") + "  (0)"
      ListView_SetItemCountEx(hMatchList, 1, %LVSICF_noInvalidateAll) 'max rows
   End If
End Sub

Sub SaveSession
   'SessionFolders
   Open $SessionFolders For Binary As #1
   Put #1,, Folders()
   SetEof #1
   Close #1
   'SessionMatch
   Open $SessionMatch For Binary As #1
   Put #1,, Matches()
   SetEof #1
   Close #1
End Sub

Sub SelectFolder
   Local title$, start$, flags&, folder$
   title$ = "Select Folder"    'if "" then "Open" is used
   start$ = IIf$(IsFolder(StartFolder),StartFolder,Exe.Path$)
   flags& = %BIF_ReturnOnlyFSDirs Or %BIF_DontGoBelowDomain Or %BIF_NoNewFolderButton
   Display Browse  hDlg, 100, 100, title$, start$, flags& To folder$
   If Len(folder$) Then
      StartFolder = Trim$(folder$,"\")
      Control Set Text hDlg, %IDC_StartFolder, StartFolder
   End If
End Sub

Sub SelectControlFont
   Local fName As String, fPoints, fStyle, fColor, CharSet, Style As Long
   Style = %CF_ForceFontExist Or %CF_NoScriptSel Or %CF_NoSimulations Or %CF_ScreenFonts 'Or %CF_FixedPitchOnly 'OR %CF_ScreenFonts Or
   hHook = SetWindowsHookEx(%WH_CBT, CodePtr(FontDialogProc), GetModuleHandle(""), GetCurrentThreadId)
   Display Font hDlg, 100,100, FontName, FontSize, FontStyle, Style To fName, fPoints, fStyle, fColor, CharSet
   UnhookWindowsHookEx hHook
   If Len(fName) Then
      FontName = fName : FontSize = fPoints : FontStyle = fStyle
      SetControlFonts
   End If
End Sub

Function FontDialogProc(ByVal nCode As Long, ByVal WParam As Long, ByVal LParam As Long) As Long
    Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
    Function = CallNextHookEx(ByVal hHook, ByVal nCode, ByVal WParam, ByVal LParam)
    If nCode < 0 Then Exit Function
    If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx hHook
    If nCode = %HCBT_CREATEWND Then
        cw = LParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
        cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
        GetClassName WParam, szTemp, %Max_Path      ' for each window / control as it is created
        If UCase$(szTemp) = "#32770" Then @cst.cy = @cst.cy - 165 : @cst.cx = @cst.cx - 10  'dialog
    End If
End Function

Function NewTextProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x As Long, y As Long
   Select Case Msg
      Case %WM_ContextMenu
         SetFocus wParam
         x = Lo(Integer,lParam) : y = Hi(Integer, lParam)    'WM_ContextMenu returns xy coordinates of mouse
         TrackPopupMenu hContextT, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
         Function = 0 : Exit Function
   End Select
   Function = CallWindowProc(OldProc&, hWnd, Msg, wParam, lParam)
End Function

Sub CreateContextMenus
   'ListBoxes
   Menu New PopUp To hContext
   Menu Add String, hContext, "Clear Search Results", %IDM_Clear, %MF_Enabled
   Menu Add String, hContext, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hContext, "Use Selected Folder As Start Folder", %IDM_UseSelected, %MF_Enabled
   Menu Add String, hContext, "Use c:\ As Start Folder", %IDM_UseC, %MF_Enabled
   'TextBoxes
   Menu New PopUp To hContextT
   Menu Add String, hContextT, "Copy",   %IDM_Copy,  %MF_Enabled
   Menu Add String, hContextT, "Cut",    %IDM_Cut,  %MF_Enabled
   Menu Add String, hContextT, "Paste",  %IDM_Paste,  %MF_Enabled
   Menu Add String, hContextT, "Delete", %IDM_Delete,  %MF_Enabled
End Sub


Sub BuildAcceleratorTable
   Local cc As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(8)
   ac(cc).fvirt = %FVIRTKEY              : ac(cc).key   = %VK_F1     : ac(cc).cmd  = %IDT_Help       : Incr cc
   ac(cc).fvirt = %FVIRTKEY              : ac(cc).key   = %VK_F3     : ac(cc).cmd  = %IDT_Search     : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_F      : ac(cc).cmd  = %IDT_Folder     : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_H      : ac(cc).cmd  = %IDT_Help       : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_M      : ac(cc).cmd  = %IDM_Method     : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_N      : ac(cc).cmd  = %IDM_Clear      : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_S      : ac(cc).cmd  = %IDT_Search     : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key   = %VK_T      : ac(cc).cmd  = %IDT_Settings   : Incr cc
   ac(cc).fvirt = %FVIRTKEY              : ac(cc).key   = %VK_Return : ac(cc).cmd  = %IDM_Return     : Incr cc
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Thread Function SearchForFolders(ByVal XUnused As Long) As Long
   Local i As Long
   MousePtr 11
   QueryPerformanceCounter qStart
   Dialog Set Text hDlg, "gbSearchSimple   v" + $ver + "   Search in work ... please wait!"

   'get search parameters
   Control Get Text hDlg, %IDC_StartFolder To StartFolder
   StartFolder = Trim$(LCase$(StartFolder),"\")
   Control Get Text hDlg, %IDC_SearchTerm To SearchTerm
   SearchTerm = LCase$(SearchTerm)
   UpdateHistoryList

   'Fill FolderList (for new Search only)
   If SearchWithin = 0 Then GetFolderList

   'Fill MatchList
   If CancelSearch Then GoTo EndOfSearch   'Detect cancel search--------------
   Select Case SearchType
      Case 0 : GetMatchingFolders
      Case 1 : GetMatchingFiles
      Case 2 : GetFilesContainingText
   End Select

EndofSearch:
   'display results of the search
   QueryPerformanceCounter qStop
   MousePtr 1
   CancelSearch = 0
   Dialog Set Text hDlg, "gbSearchSimple   v" + $ver  +  "     Search Time: " + Format$((qStop-qStart)/qFreq,"  0.###") + "s"
End Function

Sub UpdateHistoryList
   Local i As Long
   'Search Term History
   Array Scan History(0) For 5, Collate UCase,  = SearchTerm, To i
   If i Then
      'already in list - take no action
   Else
      'new search term
      Array Delete History(4)
      Array Insert History(0), SearchTerm
   End If

   'Start Folder History
   Array Scan History(5) For 5, Collate UCase, = StartFolder, To i
   If i Then
      'already in list - take no action
   Else
      'new search term
      Array Delete History(9)
      Array Insert History(5), StartFolder
   End If

   'Display New History Lists
   ListBox Reset hDlg, %IDC_SearchTermHistory
   ListBox Reset hDlg, %IDC_StartFolderHistory
   For i = 4 To 0 Step -1 : ListBox Insert hDlg, %IDC_SearchTermHistory, 1, History(i)  : Next i
   For i = 9 To 5 Step -1 : ListBox Insert hDlg, %IDC_StartFolderHistory, 1, History(i) : Next i
End Sub

Sub SetHeaderIconsOnRight(ByVal iActiveColumn As Integer, hHeader As Dword)
   Local i As Integer, hdi As HD_ITEM
   For i = 0 To Header_GetItemCount(hHeader) - 1
      hdi.mask = %HDI_FORMAT Or %HDI_IMAGE
      hdi.fmt = %HDF_String Or %HDF_Image Or %HDF_Bitmap_On_Right
      If i = iActiveColumn Then hdi.iImage = SortDirection Else hdi.iImage = 3
      Header_SetItem(hHeader, i, hdi)
   Next
End Sub

Function SortAscend(R As DirData, S As DirData) As Long
   If LCase$(R.FileName) < LCase$(S.FileName) Then Function = -1 : Exit Function
   If LCase$(R.FileName) > LCase$(S.FileName) Then Function = +1 : Exit Function
End Function

Function SortDescend(R As DirData, S As DirData) As Long
   If LCase$(R.FileName) < LCase$(S.FileName) Then Function = +1 : Exit Function
   If LCase$(R.FileName) > LCase$(S.FileName) Then Function = -1 : Exit Function
End Function

Function InputBoxProcIndent(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
'   If Debug Then Txt.Print FuncName$   '<---- turned off by choice
   Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
   Function = CallNextHookEx(ByVal hHook, ByVal nCode, ByVal wParam, ByVal lParam)
   If nCode < 0 Then Exit Function
   If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx hHook
   If nCode = %HCBT_CREATEWND Then
      cw = lParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
      cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
      GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
      If UCase$(szTemp) = "BUTTON" Then @cst.x = 120  : @cst.cx = 60           'ok and cancel
      If UCase$(szTemp) = "STATIC" Then @cst.x = 400                           'prompt
      If UCase$(szTemp) = "EDIT"   Then @cst.cx = 100 : @cst.y = @cst.y - 130  'textbox
      If UCase$(szTemp) = "EDIT"   Then SetWindowLong wparam, %GWL_Style, GetWindowLong(wParam,%GWL_Style)
      If UCase$(szTemp) = "#32770" Then @cst.cx = 200 : @cst.cy = @cst.cy - 130                'dialog
   End If
End Function

Sub GetMatchingFolders
   Local i As Long
   MatchCount = 0
   ReDim Matches(FolderCount)
   MatchCount = 0
   For i = 0 To UBound(Folders)
      If InStr( LCase$(Folders(i).FileName), SearchTerm) Then
         Incr MatchCount
         If MatchCount > UBound(Matches) Then ReDim Preserve Matches(UBound(Matches)+20000)
         Matches(MatchCount-1) = Folders(i)
      End If
      If CancelSearch Then Exit For   'Detect cancel search------------------------------------------------
   Next i
   If MatchCount Then
      ReDim Preserve Matches(MatchCount-1)
      ListView Set Header hDlg, %IDC_MatchList, 1, IIf$(SearchType,"Matching Files","Matching Folders") + "  (" + Trim$(Str$(MatchCount)) + ")"
      ListView_SetItemCountEx(hMatchList, MatchCount, %LVSICF_noInvalidateAll) 'max rows
   Else
      ReDim Matches(0)
      Matches(0).FileName = "no matches"
      ListView Set Header hDlg, %IDC_MatchList, 1, IIf$(SearchType,"Matching Files","Matching Folders") + "  (0)"
      ListView_SetItemCountEx(hMatchList, 1, %LVSICF_noInvalidateAll) 'max rows
   End If
   Control ReDraw hdlg, %IDC_MatchList
End Sub

Sub GetFilesContainingText
   Local i As Long, FileExt$, temp$, tempFile As DirData
   Clipboard Reset
   Clipboard Set Text SearchTerm
   MatchCount = 0
   ReDim Matches(100000)
   MatchCount = 0
   For i = 0 To UBound(Folders)
      temp$ = Dir$(Folders(i).FileName + "\*.*", Only %Normal To tempFile)
      tempFile.FileName = Folders(i).FileName + "\" + tempFile.FileName
      While Len(temp$)
         FileExt$ = LCase$(PathName$(Extn,temp$))
         If InStr(TextExtensions, FileExt$) Then
            'is text file - test content for search string
            Open tempFile.FileName For Binary As #1
            Get$ #1,Lof(1), FileContent$
            Close #1
            If InStr(FileContent$, SearchTerm) Then
               Incr MatchCount
               If MatchCount > UBound(Matches) Then ReDim Preserve Matches(UBound(Matches)+20000)
               Matches(MatchCount-1) = tempFile
            End If
         End If
         temp$ = Dir$(Next, To tempFile)
         tempFile.FileName = Folders(i).FileName + "\" + tempFile.FileName
         If CancelSearch Then Exit Loop   'Detect cancel search------------------------------------------------
      Wend
      If CancelSearch Then Exit For   'Detect cancel search------------------------------------------------
   Next i
   If MatchCount Then
      ReDim Preserve Matches(MatchCount-1)
      ListView Set Header hDlg, %IDC_MatchList, 1, IIf$(SearchType,"Matching Files","Matching Folders") + "  (" + Trim$(Str$(MatchCount)) + ")"
      ListView_SetItemCountEx(hMatchList, MatchCount, %LVSICF_noInvalidateAll) 'max rows
   Else
      ReDim Matches(0)
      Matches(0).FileName = "no matches"
      ListView Set Header hDlg, %IDC_MatchList, 1, IIf$(SearchType,"Matching Files","Matching Folders") + "  (0)"
      ListView_SetItemCountEx(hMatchList, 1, %LVSICF_noInvalidateAll) 'max rows
   End If
   Control ReDraw hdlg, %IDC_MatchList
End Sub

Sub GetMatchingFiles
   Local i As Long, temp$, tempFile As DirData
   MatchCount = 0
   ReDim Matches(100000)
   MatchCount = 0
   For i = 0 To UBound(Folders)
      temp$ = Dir$(Folders(i).FileName + "\*.*", Only %Normal To tempFile)
      tempFile.FileName = Folders(i).FileName + "\" + tempFile.FileName
      While Len(temp$)
         If InStr(LCase$(PathName$(Namex,tempFile.FileName)), SearchTerm) Then
            Incr MatchCount
            If MatchCount > UBound(Matches) Then ReDim Preserve Matches(UBound(Matches)+20000)
            Matches(MatchCount-1) = tempFile
         End If
         temp$ = Dir$(Next, To tempFile)
         tempFile.FileName = Folders(i).FileName + "\" + tempFile.FileName
         If CancelSearch Then Exit Loop   'Detect cancel search------------------------------------------------
      Wend
      If CancelSearch Then Exit For   'Detect cancel search------------------------------------------------
   Next i
   If MatchCount Then
      ReDim Preserve Matches(MatchCount-1)
      ListView Set Header hDlg, %IDC_MatchList, 1, IIf$(SearchType,"Matching Files","Matching Folders") + "  (" + Trim$(Str$(MatchCount)) + ")"
      ListView_SetItemCountEx(hMatchList, MatchCount, %LVSICF_noInvalidateAll) 'max rows
   Else
      ReDim Matches(0)
      Matches(0).FileName = "no matches"
      ListView Set Header hDlg, %IDC_MatchList, 1, IIf$(SearchType,"Matching Files","Matching Folders") + "  (0)"
      ListView_SetItemCountEx(hMatchList, 1, %LVSICF_noInvalidateAll) 'max rows
   End If
   Control ReDraw hdlg, %IDC_MatchList
End Sub


Sub SetSearchType
   Select Case SearchType
      Case 0
         ListView Set Header hDlg, %IDC_MatchList, 1, IIf$(SearchType,"Matching Files","Matching Folders") + "  (0)"
         MatchCount = 0
         ReDim Matches(0)
         Matches(0).FileName = "no matches"
         ListView_SetItemCountEx(hMatchList, 1, %LVSICF_noInvalidateAll) 'max rows
         Control ReDraw hDlg, %IDC_MatchList
      Case 1
         ListView Set Header hDlg, %IDC_MatchList, 1, IIf$(SearchType,"Matching Files","Matching Folders") + "  (0)"
         MatchCount = 0
         ReDim Matches(0)
         Matches(0).FileName = "no matches"
         ListView_SetItemCountEx(hMatchList, 1, %LVSICF_noInvalidateAll) 'max rows
         Control ReDraw hDlg, %IDC_MatchList
      Case 2
         ListView Set Header hDlg, %IDC_MatchList, 1, IIf$(SearchType,"Matching Files","Matching Folders") + "  (0)"
         MatchCount = 0
         ReDim Matches(0)
         Matches(0).FileName = "no matches"
         ListView_SetItemCountEx(hMatchList, 1, %LVSICF_noInvalidateAll) 'max rows
         Control ReDraw hDlg, %IDC_MatchList
   End Select

   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_SearchFolders, %TBState_Checked * IIf(SearchType=0,1,0) Or %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_SearchFiles, %TBState_Checked * IIf(SearchType=1,1,0) Or %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_SearchText, %TBState_Checked * IIf(SearchType=2,1,0) Or %TBState_Enabled
End Sub
